<template>
  <div class="q-pa-sm">
    <q-card
      bordered
      flat
    >
      <q-card-section>
        <div class="text-h5 text-weight-bolder text-grey-9 q-pa-sm">
          Dados do Cartão
        </div>
      </q-card-section>

      <q-card-section>
        <q-form class="row q-gutter-y-lg q-pb-md">
          <q-input
            v-model="value.cardNumber"
            class="col-6 q-pa-sm"
            label="Número do Cartão"
            color="primary"
            mask="#### #### #### ####"
            unmasked-value
            bottom-slots
            outlined
            dense
            :error="vuelidate.cardNumber.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.cardNumber)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            v-model="value.cardHolderName"
            class="col-6 q-pa-sm"
            label="Nome no Cartão"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="vuelidate.cardHolderName.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.cardHolderName)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            v-model="value.cardExpirationDate"
            class="col-6 q-pa-sm"
            label="Vencimento"
            color="primary"
            mask="##/##"
            unmasked-value
            bottom-slots
            outlined
            dense
            :error="vuelidate.cardExpirationDate.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.cardExpirationDate)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            v-model="value.cardCvv"
            :type="isCvv ? 'password' : 'text'"
            class="col-6 q-pa-sm"
            label="Código de Segurança"
            color="primary"
            mask="###"
            unmasked-value
            bottom-slots
            outlined
            dense
            :error="vuelidate.cardCvv.$error"
          >
            <template v-slot:append>
              <q-icon
                class="cursor-pointer"
                :name="isCvv ? 'visibility_off' : 'visibility'"
                @click="isCvv = !isCvv"
              />
            </template>

            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.cardCvv)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-toggle
            v-model="value.customer.sameAsUser"
            class="col-6"
            label="O aluno é o titular do cartão"
          />

          <q-toggle
            v-model="value.customer.sameUserAddress"
            class="col-6"
            label="O endereço do aluno é o mesmo de cobrança"
          />
        </q-form>
      </q-card-section>
    </q-card>
  </div>
</template>

<script>
import { ErrorMessagesMixin } from '../../mixin/error-messages'
import { isDate } from 'brazilian-values'
import { date } from 'quasar'

export default {
  name: 'Payment',
  mixins: [ErrorMessagesMixin],
  props: {
    value: {
      type: Object,
      default: () => ({})
    },
    vuelidate: {
      type: Object,
      default: () => ({})
    }
  },
  data () {
    return {
      isCvv: true
    }
  },
  computed: {
    phoneMask () {
      return this.value.customer.phone.number.length < 11 ? '(##) ####-#####' : '(##) #####-####'
    },
    defaultYearMonth () {
      return date.formatDate(date.subtractFromDate(new Date(), { year: 18 }), 'YYYY/MM')
    }
  },
  watch: {
    'value.customer.bornAt' (bornAt) {
      if (!isDate(bornAt)) {
        this.value.customer.bornAt = ''
      }
    }
  },
  methods: {
    options (optionDate) {
      return optionDate <= date.formatDate(date.subtractFromDate(new Date(), { year: 18 }), 'YYYY/MM/DD')
    }
  }
}
</script>
